net.sf.cpsolver.coursett

## Class TimetableSolver

- java.lang.Object
- - net.sf.cpsolver.ifs.solver.Solver<Lecture,Placement>
  - - net.sf.cpsolver.coursett.TimetableSolver

-     public class TimetableSolver
      extends Solver<Lecture,Placement>

  University course timetabling solver.
  When a complete solution is found, it is improved by limited depth backtracking search. This way it is ensured that the fund solution is at least locally optimal.
  Version:
    CourseTT 1.2 (University Course Timetabling)
    Copyright (C) 2006 - 2010 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.cpsolver.ifs.solver.Solver

      `Solver.SolverThread`

  - ### Field Summary

    - ### Fields inherited from class net.sf.cpsolver.ifs.solver.Solver

      `iCurrentSolution, iLastSolution, iSolverThread, iStop, sLogger, THREAD_PRIORITY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimetableSolver(DataProperties properties)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `fixCompleteSolution(double startTime)` Try to improve existing solution by backtracking search of very limited depth.
    `void` | `initSolver()`
    `protected void` | `onAssigned(double startTime)` Called in each iteration, after a neighbour is assigned

    - ### Methods inherited from class net.sf.cpsolver.ifs.solver.Solver

      `addExtension, addSolverListener, autoConfigure, clearBest, currentSolution, dispose, getExtensions, getNeighbourSelection, getPerturbationsCounter, getProperties, getSolutionComparator, getSolverListeners, getSolverThread, getTerminationCondition, init, isRunning, isStop, lastSolution, onFailure, onFinish, onStart, onStop, removeSolverListener, setInitalSolution, setInitalSolution, setNeighbourSelection, setPerturbationsCounter, setSolutionComparator, setTerminalCondition, setUpdateProgress, start, stopSolver, stopSolver`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TimetableSolver

          public TimetableSolver(DataProperties properties)

  - ### Method Detail

    - #### initSolver

          public void initSolver()

      Overrides:
        `initSolver` in class `Solver<Lecture,Placement>`

    - #### onAssigned

          protected void onAssigned(double startTime)

      Description copied from class: `Solver`
      Called in each iteration, after a neighbour is assigned
      Overrides:
        `onAssigned` in class `Solver<Lecture,Placement>`

    - #### fixCompleteSolution

          protected void fixCompleteSolution(double startTime)

      Try to improve existing solution by backtracking search of very limited depth. See `NeighbourSelectionWithSuggestions` for more details.